; converts a memory block type code into char representation
; in: al
; out: al
; destroys ah
mm_type:
  push bp
  push si
  mov bp,.typechar
  and ax,0x00FF
  mov si,ax
  mov al,[bp+si]
  pop si
  pop bp
  ret
.typechar:
  db "F?ARU", 0

mm_print:
  push cs
  pop ds
  mov cx,0x0000
  mov bp,memtab
  mov si,0x0000

.loop:
  push si

  mov ax, bp
  add ax, si
  add ax, 0x06
  push ax

  mov al,[bp+si+0x05]
  push ax ; task id

  mov al,[bp+si+0x04]
  call mm_type
  push ax ; memory type

  mov bx,cx
  add cx,[bp+si+0x00]
  mov ax,cx
  dec ax
  push ax ; end addr
  push bx ; start addr

  mov si,.linefmt
  call kprintf

  pop ax
  pop ax
  pop ax
  pop ax
  pop ax
  pop si

  ; look for next line
  mov ax,[bp+si+0x02]
  test ax,0xFFFF
  mov si,ax
  jnz .loop
  ret
.linefmt:
  db "%X0 %XF %c %x %s", 0

; pre-filled table for memory management
align 16
memtab:
  ; interrupt vector table
  dw 0x0040
  dw 0x0010
  db 3
  db 0
  db "IVT", 0
align 16
  ; bios data area (writes here during runtime)
  dw 0x0010
  dw 0x0020
  db 3
  db 0
  db "BIOS DATA", 0
align 16
  dw 0x9FB0
  dw 0x0030
  db 1
  db 0
  db 0
align 16
  dw 0x2000
  dw 0x0040
  db 4
  db 0
  db "I/O BUS", 0
align 16
  dw 0x3000
  dw 0x0050
  db 4
  db 0
  db "BIOS EXT", 0
align 16
  dw 0x1000
  dw 0x0000
  db 4
  db 0
  db "BIOS", 0
